package com.mycompany.plugin.mytweets;

import com.codename1.components.InfiniteProgress;
import com.codename1.components.MultiButton;
import com.codename1.io.ConnectionRequest;
import com.codename1.io.JSONParser;
import com.codename1.io.NetworkManager;
import com.codename1.maker.MakerPlugin;
import com.codename1.ui.Button;
import com.codename1.ui.Container;
import com.codename1.ui.Display;
import com.codename1.ui.Label;
import com.codename1.ui.TextArea;
import com.codename1.ui.events.ActionEvent;
import com.codename1.ui.events.ActionListener;
import com.codename1.ui.layouts.BorderLayout;
import com.codename1.ui.layouts.BoxLayout;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Hashtable;
import java.util.Vector;

/**
 * This is simple hello world maker plugin showing how we can get arguments and then use Codename One
 * to provide all sorts of functionality
 *
 * @author Shai Almog
 */
public class Plugin extends MakerPlugin {

    @Override
    public String getPackageName() {
        return "com.mycompany.plugin.mytweets";
    }

    @Override
    public String getDeveloperEmailId() {
        return "youremailhere@x.com";
    }

    @Override
    public String getPluginName() {
        return "My Tweets";
    }

    @Override
    public Container createEmbeddedUI() {
        final Container tweets = new Container(new BoxLayout(BoxLayout.Y_AXIS));
        tweets.setScrollableY(true);
        ConnectionRequest t = new ConnectionRequest() {
            private Hashtable h;
            @Override
            protected void readResponse(InputStream input) throws IOException {
                JSONParser jp = new JSONParser();
                h = jp.parse(new InputStreamReader(input));
            }

            @Override
            protected void postResponse() {
                Vector v = (Vector)h.get("results");
                tweets.removeAll();
                for(Object currentObj : v) {
                    Hashtable current = (Hashtable)currentObj;
                    String user = (String)current.get("from_user_name");
                    String date = (String)current.get("created_at");
                    String text = (String)current.get("text");
                    String url = "";
                    int indi = text.indexOf("http://t.co/");
                    if(indi > -1) {
                        int last = text.indexOf(' ', indi);
                        if(last == -1) {
                            last = last = text.length();
                        }
                        url = text.substring(indi, last);
                    }
                    final String finalURL = url;
                    Container entry = new Container(new BorderLayout());
                    entry.setUIID("MultiButton");
                    TextArea t = new TextArea(text);
                    t.setEditable(false);
                    t.setUIID("MultiLine1");
                    Button lead = new Button();
                    lead.setUIID("Label");
                    entry.addComponent(BorderLayout.CENTER, t);
                    entry.addComponent(BorderLayout.EAST, lead);
                    Container south = new Container(new BorderLayout());
                    entry.addComponent(BorderLayout.SOUTH, south);
                    Label dateText = new Label(date);
                    dateText.setUIID("MultiLine2");
                    Label name = new Label(user);
                    name.setUIID("MultiLine3");
                    south.addComponent(BorderLayout.CENTER, dateText);
                    south.addComponent(BorderLayout.EAST, name);
                    entry.setLeadComponent(lead);
                    tweets.addComponent(entry);
                    lead.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent evt) {
                            if(finalURL != null && finalURL.length() > 0) {
                                Display.getInstance().execute(finalURL);
                            }
                        }
                    });
                }
                tweets.animateLayout(350);
            }
            
            
        };
        t.setUrl("http://search.twitter.com/search.json");
        t.setPost(false);
        t.setContentType("application/json");
        t.addRequestHeader("Accept", "application/json");
        
        // we pass arguments to the plugin via the meta data, the argument types
        // are declated in the plugin XML
        String user = (String)getMetaData().get("user");
        if(user == null || user.length() == 0) {
            user = "@codename-one";
        } else {
            if(!user.startsWith("@")) {
                user = "@" + user;
            }
        }
        t.addArgument("q", user);
        tweets.addComponent(new InfiniteProgress());
        NetworkManager.getInstance().addToQueue(t);
        return tweets;
    }
}
